// TowersOfHanoi.java
// Program solves the towers of Hanoi problem, and
// demonstrates recursion.

public class TowersOfHanoi
{
   private int numDisks; // number of disks to move

   public TowersOfHanoi( int disks )
   {
      numDisks = disks;
   } // end constructor TowersOfHanoi 

   // recusively move disks through towers
   public void solveTowers( int disks, int sourcePeg, int destinationPeg,
      int tempPeg )
   {
      // base case -- only one disk to move
      if ( disks == 1 )
      {
         System.out.println( "\n"+sourcePeg+ "--> "+ destinationPeg );
         return;
      } // end if

      // recursion step -- move disk to tempPeg, then to destinationPeg
      // move ( disks - 1 ) disks from sourcePeg to tempPeg recursively
      solveTowers( disks - 1, sourcePeg, tempPeg, destinationPeg );

      // move last disk from sourcePeg to destinationPeg
      System.out.println( "\n"+sourcePeg+ "--> "+ destinationPeg );

      // move ( disks - 1 ) disks from tempPeg to destinationPeg
      solveTowers( disks - 1, tempPeg, destinationPeg, sourcePeg );
   } // end method solveTowers
} // end class TowersOfHanoi
